#   Copyright (c) 2020 Lenovo.  All rights reserved.

#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at

#       http://www.apache.org/licenses/LICENSE-2.0

#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.


"""
    CP Web Services (CPWS)

    CP web services provides API access to the ThinkAgile CP on-premises cloud platform. It provides access to virtual datacenter and infrastructure resources and is used to create resizable resources, manage workloads and retrieve information about the underlying infrastructure. CPWS will continue to grow as new capabilities are added to the platform.  # noqa: E501

    OpenAPI spec version: Beta
    Contact: lenovo-email
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from tacp.api_client import ApiClient


class ComputeNodesApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_compute_node_information_using_get(self, uuid, **kwargs):  # noqa: E501
        """View the properties of a compute node  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_compute_node_information_using_get(uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str uuid: uuid (required)
        :param list[str] fields: Selector specifying a subset of fields to include in the response. Supports dotted notation to traverse into child objects. (Example: ?fields=foo.bar.uuid,foo.name)
        :return: ApiComputeNodeFirmwareUpdatePayload
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_compute_node_information_using_get_with_http_info(uuid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_compute_node_information_using_get_with_http_info(uuid, **kwargs)  # noqa: E501
            return data

    def get_compute_node_information_using_get_with_http_info(self, uuid, **kwargs):  # noqa: E501
        """View the properties of a compute node  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_compute_node_information_using_get_with_http_info(uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str uuid: uuid (required)
        :param list[str] fields: Selector specifying a subset of fields to include in the response. Supports dotted notation to traverse into child objects. (Example: ?fields=foo.bar.uuid,foo.name)
        :return: ApiComputeNodeFirmwareUpdatePayload
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['uuid', 'fields']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_compute_node_information_using_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'uuid' is set
        if ('uuid' not in params or
                params['uuid'] is None):
            raise ValueError("Missing the required parameter `uuid` when calling `get_compute_node_information_using_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'uuid' in params:
            path_params['uuid'] = params['uuid']  # noqa: E501

        query_params = []
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
            collection_formats['fields'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKey']  # noqa: E501

        return self.api_client.call_api(
            '/api/latest/compute-nodes/{uuid}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiComputeNodeFirmwareUpdatePayload',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_compute_node_stats_using_get(self, uuid, **kwargs):  # noqa: E501
        """View the statistics of a compute node  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_compute_node_stats_using_get(uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str uuid: uuid (required)
        :param datetime end_timestamp: return statistics for a compute node finishing at the specified timestamp. Timestamp should be in the user's timezone.
        :param list[str] fields: Selector specifying a subset of fields to include in the response. Supports dotted notation to traverse into child objects. (Example: ?fields=foo.bar.uuid,foo.name)
        :param str filters: Selector specifying filters in FIQL notation to apply to the response items. Supports dotted notation to traverse into child objects. (Example: ?filters=foo.bar.id=in=(1,2,3) or foo.bar.name==\"name\") Supported comparison operators: Equal to: == Not equal to: != Less than: =lt= or < Less than or equal to: =le= or <= Greater than operator: =gt= or > Greater than or equal to: =ge= or >= In: =in= Not in: =out=
        :param int limit: limit the number of compute node statistics returned
        :param int offset: returns compute node statistics starting at the specified index in the list
        :param datetime start_timestamp: return statistics for a compute node starting at the specified timestamp. Timestamp should be in the user's timezone.
        :return: list[ApiComputeNodeStatsPayload]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_compute_node_stats_using_get_with_http_info(uuid, **kwargs)  # noqa: E501
        else:
            (data) = self.get_compute_node_stats_using_get_with_http_info(uuid, **kwargs)  # noqa: E501
            return data

    def get_compute_node_stats_using_get_with_http_info(self, uuid, **kwargs):  # noqa: E501
        """View the statistics of a compute node  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_compute_node_stats_using_get_with_http_info(uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str uuid: uuid (required)
        :param datetime end_timestamp: return statistics for a compute node finishing at the specified timestamp. Timestamp should be in the user's timezone.
        :param list[str] fields: Selector specifying a subset of fields to include in the response. Supports dotted notation to traverse into child objects. (Example: ?fields=foo.bar.uuid,foo.name)
        :param str filters: Selector specifying filters in FIQL notation to apply to the response items. Supports dotted notation to traverse into child objects. (Example: ?filters=foo.bar.id=in=(1,2,3) or foo.bar.name==\"name\") Supported comparison operators: Equal to: == Not equal to: != Less than: =lt= or < Less than or equal to: =le= or <= Greater than operator: =gt= or > Greater than or equal to: =ge= or >= In: =in= Not in: =out=
        :param int limit: limit the number of compute node statistics returned
        :param int offset: returns compute node statistics starting at the specified index in the list
        :param datetime start_timestamp: return statistics for a compute node starting at the specified timestamp. Timestamp should be in the user's timezone.
        :return: list[ApiComputeNodeStatsPayload]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['uuid', 'end_timestamp', 'fields', 'filters', 'limit', 'offset', 'start_timestamp']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_compute_node_stats_using_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'uuid' is set
        if ('uuid' not in params or
                params['uuid'] is None):
            raise ValueError("Missing the required parameter `uuid` when calling `get_compute_node_stats_using_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'uuid' in params:
            path_params['uuid'] = params['uuid']  # noqa: E501

        query_params = []
        if 'end_timestamp' in params:
            query_params.append(('end-timestamp', params['end_timestamp']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
            collection_formats['fields'] = 'csv'  # noqa: E501
        if 'filters' in params:
            query_params.append(('filters', params['filters']))  # noqa: E501
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501
        if 'offset' in params:
            query_params.append(('offset', params['offset']))  # noqa: E501
        if 'start_timestamp' in params:
            query_params.append(('start-timestamp', params['start_timestamp']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKey']  # noqa: E501

        return self.api_client.call_api(
            '/api/latest/compute-nodes/{uuid}/stats', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[ApiComputeNodeStatsPayload]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_compute_nodes_for_organization_using_get(self, **kwargs):  # noqa: E501
        """View compute nodes for an organization  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_compute_nodes_for_organization_using_get(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param list[str] fields: Selector specifying a subset of fields to include in the response. Supports dotted notation to traverse into child objects. (Example: ?fields=foo.bar.uuid,foo.name)
        :param str filters: Selector specifying filters in FIQL notation to apply to the response items. Supports dotted notation to traverse into child objects. (Example: ?filters=foo.bar.id=in=(1,2,3) or foo.bar.name==\"name\") Supported comparison operators: Equal to: == Not equal to: != Less than: =lt= or < Less than or equal to: =le= or <= Greater than operator: =gt= or > Greater than or equal to: =ge= or >= In: =in= Not in: =out=
        :param int limit: limit the number of compute nodes returned
        :param int offset: returns compute nodes starting at the specified index in the list
        :return: list[ApiComputeNodeFirmwareUpdatePayload]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_compute_nodes_for_organization_using_get_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_compute_nodes_for_organization_using_get_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_compute_nodes_for_organization_using_get_with_http_info(self, **kwargs):  # noqa: E501
        """View compute nodes for an organization  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_compute_nodes_for_organization_using_get_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param list[str] fields: Selector specifying a subset of fields to include in the response. Supports dotted notation to traverse into child objects. (Example: ?fields=foo.bar.uuid,foo.name)
        :param str filters: Selector specifying filters in FIQL notation to apply to the response items. Supports dotted notation to traverse into child objects. (Example: ?filters=foo.bar.id=in=(1,2,3) or foo.bar.name==\"name\") Supported comparison operators: Equal to: == Not equal to: != Less than: =lt= or < Less than or equal to: =le= or <= Greater than operator: =gt= or > Greater than or equal to: =ge= or >= In: =in= Not in: =out=
        :param int limit: limit the number of compute nodes returned
        :param int offset: returns compute nodes starting at the specified index in the list
        :return: list[ApiComputeNodeFirmwareUpdatePayload]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['fields', 'filters', 'limit', 'offset']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_compute_nodes_for_organization_using_get" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
            collection_formats['fields'] = 'csv'  # noqa: E501
        if 'filters' in params:
            query_params.append(('filters', params['filters']))  # noqa: E501
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501
        if 'offset' in params:
            query_params.append(('offset', params['offset']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKey']  # noqa: E501

        return self.api_client.call_api(
            '/api/latest/compute-nodes', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[ApiComputeNodeFirmwareUpdatePayload]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_tags_to_compute_node_using_put(self, body, uuid, **kwargs):  # noqa: E501
        """Update tags for Compute Node  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_tags_to_compute_node_using_put(body, uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ApiUpdateTagsForComputeNodePayload body: payload (required)
        :param str uuid: uuid (required)
        :return: ApiMessagePayload
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_tags_to_compute_node_using_put_with_http_info(body, uuid, **kwargs)  # noqa: E501
        else:
            (data) = self.update_tags_to_compute_node_using_put_with_http_info(body, uuid, **kwargs)  # noqa: E501
            return data

    def update_tags_to_compute_node_using_put_with_http_info(self, body, uuid, **kwargs):  # noqa: E501
        """Update tags for Compute Node  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_tags_to_compute_node_using_put_with_http_info(body, uuid, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ApiUpdateTagsForComputeNodePayload body: payload (required)
        :param str uuid: uuid (required)
        :return: ApiMessagePayload
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'uuid']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_tags_to_compute_node_using_put" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `update_tags_to_compute_node_using_put`")  # noqa: E501
        # verify the required parameter 'uuid' is set
        if ('uuid' not in params or
                params['uuid'] is None):
            raise ValueError("Missing the required parameter `uuid` when calling `update_tags_to_compute_node_using_put`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'uuid' in params:
            path_params['uuid'] = params['uuid']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKey']  # noqa: E501

        return self.api_client.call_api(
            '/api/latest/compute-nodes/{uuid}/tags', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiMessagePayload',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
