#   Copyright (c) 2020 Lenovo.  All rights reserved.

#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at

#       http://www.apache.org/licenses/LICENSE-2.0

#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.


# flake8: noqa
"""
    CP Web Services (CPWS)

    CP web services provides API access to the ThinkAgile CP on-premises cloud platform. It provides access to virtual datacenter and infrastructure resources and is used to create resizable resources, manage workloads and retrieve information about the underlying infrastructure. CPWS will continue to grow as new capabilities are added to the platform.  # noqa: E501

    OpenAPI spec version: Beta
    Contact: lenovo-email
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

# import models into model package
from tacp.models.api_action_payload import ApiActionPayload
from tacp.models.api_action_status_payload import ApiActionStatusPayload
from tacp.models.api_add_vnic_payload import ApiAddVnicPayload
from tacp.models.api_application_group_payload import ApiApplicationGroupPayload
from tacp.models.api_application_instance_properties_payload import ApiApplicationInstancePropertiesPayload
from tacp.models.api_application_instance_stats_payload import ApiApplicationInstanceStatsPayload
from tacp.models.api_application_template_operating_system_payload import ApiApplicationTemplateOperatingSystemPayload
from tacp.models.api_application_template_properties_payload import ApiApplicationTemplatePropertiesPayload
from tacp.models.api_applications_for_application_group_payload import ApiApplicationsForApplicationGroupPayload
from tacp.models.api_automated_snapshot_policy_payload import ApiAutomatedSnapshotPolicyPayload
from tacp.models.api_boot_order_payload import ApiBootOrderPayload
from tacp.models.api_category_allocation_for_migration_zone_payload import ApiCategoryAllocationForMigrationZonePayload
from tacp.models.api_category_allocation_payload import ApiCategoryAllocationPayload
from tacp.models.api_compute_hardware_properties_payload import ApiComputeHardwarePropertiesPayload
from tacp.models.api_compute_node_firmware_update_payload import ApiComputeNodeFirmwareUpdatePayload
from tacp.models.api_compute_node_stats_payload import ApiComputeNodeStatsPayload
from tacp.models.api_controller_status_payload import ApiControllerStatusPayload
from tacp.models.api_cpu_temperature_payload import ApiCpuTemperaturePayload
from tacp.models.api_create_application_group_payload import ApiCreateApplicationGroupPayload
from tacp.models.api_create_application_payload import ApiCreateApplicationPayload
from tacp.models.api_create_datacenter_category_allocation_payload import ApiCreateDatacenterCategoryAllocationPayload
from tacp.models.api_create_datacenter_payload import ApiCreateDatacenterPayload
from tacp.models.api_create_datacenter_resource_payload import ApiCreateDatacenterResourcePayload
from tacp.models.api_create_or_edit_application_network_options_payload import ApiCreateOrEditApplicationNetworkOptionsPayload
from tacp.models.api_create_snapshot_payload import ApiCreateSnapshotPayload
from tacp.models.api_create_template_from_application_payload import ApiCreateTemplateFromApplicationPayload
from tacp.models.api_create_vnet_payload import ApiCreateVnetPayload
from tacp.models.api_datacenter_allocation_for_migration_zone_payload import ApiDatacenterAllocationForMigrationZonePayload
from tacp.models.api_datacenter_flash_pool_payload import ApiDatacenterFlashPoolPayload
from tacp.models.api_datacenter_migration_zone_payload import ApiDatacenterMigrationZonePayload
from tacp.models.api_datacenter_properties_payload import ApiDatacenterPropertiesPayload
from tacp.models.api_disaster_recovery_policy_payload import ApiDisasterRecoveryPolicyPayload
from tacp.models.api_disaster_recovery_retention_count_payload import ApiDisasterRecoveryRetentionCountPayload
from tacp.models.api_disk_bandwidth_payload import ApiDiskBandwidthPayload
from tacp.models.api_disk_iops_payload import ApiDiskIopsPayload
from tacp.models.api_disk_payload import ApiDiskPayload
from tacp.models.api_disk_size_and_limit_payload import ApiDiskSizeAndLimitPayload
from tacp.models.api_disk_size_payload import ApiDiskSizePayload
from tacp.models.api_disk_stats_payload import ApiDiskStatsPayload
from tacp.models.api_edit_application_group_payload import ApiEditApplicationGroupPayload
from tacp.models.api_edit_application_payload import ApiEditApplicationPayload
from tacp.models.api_firewall_profile_properties_payload import ApiFirewallProfilePropertiesPayload
from tacp.models.api_firewall_profile_rule_properties_payload import ApiFirewallProfileRulePropertiesPayload
from tacp.models.api_flash_pool_allocation_payload import ApiFlashPoolAllocationPayload
from tacp.models.api_flash_pool_properties_payload import ApiFlashPoolPropertiesPayload
from tacp.models.api_flash_pool_stats_payload import ApiFlashPoolStatsPayload
from tacp.models.api_import_vm_to_application_template_payload import ApiImportVmToApplicationTemplatePayload
from tacp.models.api_marketplace_template_payload import ApiMarketplaceTemplatePayload
from tacp.models.api_marketplace_template_properties_payload import ApiMarketplaceTemplatePropertiesPayload
from tacp.models.api_message_payload import ApiMessagePayload
from tacp.models.api_migration_zone_allocation_payload import ApiMigrationZoneAllocationPayload
from tacp.models.api_migration_zone_properties_payload import ApiMigrationZonePropertiesPayload
from tacp.models.api_migration_zone_stats_payload import ApiMigrationZoneStatsPayload
from tacp.models.api_name_payload import ApiNamePayload
from tacp.models.api_network_payload import ApiNetworkPayload
from tacp.models.api_notification_payload import ApiNotificationPayload
from tacp.models.api_os_version_options_payload import ApiOsVersionOptionsPayload
from tacp.models.api_shared_storage_payload import ApiSharedStoragePayload
from tacp.models.api_simple_id_payload import ApiSimpleIdPayload
from tacp.models.api_simple_payload import ApiSimplePayload
from tacp.models.api_slam_action_request_payload import ApiSlamActionRequestPayload
from tacp.models.api_slam_action_request_with_message_payload import ApiSlamActionRequestWithMessagePayload
from tacp.models.api_snapshot_boot_order_payload import ApiSnapshotBootOrderPayload
from tacp.models.api_snapshot_disaster_recovery_information_payload import ApiSnapshotDisasterRecoveryInformationPayload
from tacp.models.api_snapshot_payload import ApiSnapshotPayload
from tacp.models.api_static_binding_rule_payload import ApiStaticBindingRulePayload
from tacp.models.api_storage_block_payload import ApiStorageBlockPayload
from tacp.models.api_storage_controller_payload import ApiStorageControllerPayload
from tacp.models.api_ui_tag_payload import ApiUiTagPayload
from tacp.models.api_update_networks_for_datacenter_payload import ApiUpdateNetworksForDatacenterPayload
from tacp.models.api_update_tags_for_compute_node_payload import ApiUpdateTagsForComputeNodePayload
from tacp.models.api_user_payload import ApiUserPayload
from tacp.models.api_uuid_payload import ApiUuidPayload
from tacp.models.api_version_payload import ApiVersionPayload
from tacp.models.api_vlan_properties_payload import ApiVlanPropertiesPayload
from tacp.models.api_vnet_dhcp_service_payload import ApiVnetDhcpServicePayload
from tacp.models.api_vnet_payload import ApiVnetPayload
from tacp.models.api_vnet_properties_payload import ApiVnetPropertiesPayload
from tacp.models.api_vnet_routing_service_payload import ApiVnetRoutingServicePayload
from tacp.models.api_vnic_payload import ApiVnicPayload
