#   Copyright (c) 2020 Lenovo.  All rights reserved.

#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at

#       http://www.apache.org/licenses/LICENSE-2.0

#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.


"""
    CP Web Services (CPWS)

    CP web services provides API access to the ThinkAgile CP on-premises cloud platform. It provides access to virtual datacenter and infrastructure resources and is used to create resizable resources, manage workloads and retrieve information about the underlying infrastructure. CPWS will continue to grow as new capabilities are added to the platform.  # noqa: E501

    OpenAPI spec version: Beta
    Contact: lenovo-email
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import unittest

import tacp
from api.applications_api import ApplicationsApi  # noqa: E501
from tacp.rest import ApiException


class TestApplicationsApi(unittest.TestCase):
    """ApplicationsApi unit test stubs"""

    def setUp(self):
        self.api = api.applications_api.ApplicationsApi()  # noqa: E501

    def tearDown(self):
        pass

    def test_clone_and_attach_disk_to_application_using_put(self):
        """Test case for clone_and_attach_disk_to_application_using_put

        Clone and attach a disk to an application  # noqa: E501
        """
        pass

    def test_create_application_from_snapshot_using_post(self):
        """Test case for create_application_from_snapshot_using_post

        Create an application from a snapshot  # noqa: E501
        """
        pass

    def test_create_application_from_template_using_post(self):
        """Test case for create_application_from_template_using_post

        Create an application from a template  # noqa: E501
        """
        pass

    def test_create_snapshot_for_application_using_post(self):
        """Test case for create_snapshot_for_application_using_post

        Create a snapshot for an application  # noqa: E501
        """
        pass

    def test_delete_application_using_delete(self):
        """Test case for delete_application_using_delete

        Delete an application  # noqa: E501
        """
        pass

    def test_delete_snapshot_for_application_using_delete(self):
        """Test case for delete_snapshot_for_application_using_delete

        Deleting snapshot for an application  # noqa: E501
        """
        pass

    def test_edit_application_using_put(self):
        """Test case for edit_application_using_put

        Edit an application (deprecated)  # noqa: E501
        """
        pass

    def test_force_restart_application_using_put(self):
        """Test case for force_restart_application_using_put

        Force restart an application  # noqa: E501
        """
        pass

    def test_get_application_disk_stats_using_get(self):
        """Test case for get_application_disk_stats_using_get

        View disk statistics for an application  # noqa: E501
        """
        pass

    def test_get_application_stats_using_get(self):
        """Test case for get_application_stats_using_get

        View statistics for an application  # noqa: E501
        """
        pass

    def test_get_application_using_get(self):
        """Test case for get_application_using_get

        View an application  # noqa: E501
        """
        pass

    def test_get_applications_using_get(self):
        """Test case for get_applications_using_get

        View applications for an organization  # noqa: E501
        """
        pass

    def test_get_firewall_overrides_for_application_using_get(self):
        """Test case for get_firewall_overrides_for_application_using_get

        View a list of firewall overrides for an application  # noqa: E501
        """
        pass

    def test_get_snapshot_using_get(self):
        """Test case for get_snapshot_using_get

        View a snapshot for an application  # noqa: E501
        """
        pass

    def test_get_snapshots_for_application_using_get(self):
        """Test case for get_snapshots_for_application_using_get

        View snapshots for an application  # noqa: E501
        """
        pass

    def test_pause_application_using_put(self):
        """Test case for pause_application_using_put

        Pause an application  # noqa: E501
        """
        pass

    def test_rename_snapshot_using_put(self):
        """Test case for rename_snapshot_using_put

        Rename a snapshot  # noqa: E501
        """
        pass

    def test_restart_application_using_put(self):
        """Test case for restart_application_using_put

        Restart an application  # noqa: E501
        """
        pass

    def test_resume_application_using_put(self):
        """Test case for resume_application_using_put

        Resume an application  # noqa: E501
        """
        pass

    def test_shutdown_application_using_put(self):
        """Test case for shutdown_application_using_put

        Shutdown an application  # noqa: E501
        """
        pass

    def test_start_application_using_put(self):
        """Test case for start_application_using_put

        Start an application  # noqa: E501
        """
        pass

    def test_stop_application_using_put(self):
        """Test case for stop_application_using_put

        Stop an application  # noqa: E501
        """
        pass


if __name__ == '__main__':
    unittest.main()
