#   Copyright (c) 2020 Lenovo.  All rights reserved.

#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at

#       http://www.apache.org/licenses/LICENSE-2.0

#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.


"""
    CP Web Services (CPWS)

    CP web services provides API access to the ThinkAgile CP on-premises cloud platform. It provides access to virtual datacenter and infrastructure resources and is used to create resizable resources, manage workloads and retrieve information about the underlying infrastructure. CPWS will continue to grow as new capabilities are added to the platform.  # noqa: E501

    OpenAPI spec version: Beta
    Contact: lenovo-email
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import unittest

import tacp
from api.edit_applications_api import EditApplicationsApi  # noqa: E501
from tacp.rest import ApiException


class TestEditApplicationsApi(unittest.TestCase):
    """EditApplicationsApi unit test stubs"""

    def setUp(self):
        self.api = api.edit_applications_api.EditApplicationsApi()  # noqa: E501

    def tearDown(self):
        pass

    def test_create_application_disk_using_post(self):
        """Test case for create_application_disk_using_post

        Add a disk to an application  # noqa: E501
        """
        pass

    def test_create_application_vnic_using_post(self):
        """Test case for create_application_vnic_using_post

        Add a vNIC to an application  # noqa: E501
        """
        pass

    def test_delete_application_disk_using_delete(self):
        """Test case for delete_application_disk_using_delete

        Delete a disk from an application  # noqa: E501
        """
        pass

    def test_delete_application_vnic_using_delete(self):
        """Test case for delete_application_vnic_using_delete

        Delete a vNIC from an application  # noqa: E501
        """
        pass

    def test_edit_application_boot_order_using_put(self):
        """Test case for edit_application_boot_order_using_put

        Update the boot order for an application  # noqa: E501
        """
        pass

    def test_edit_application_compute_category_using_put(self):
        """Test case for edit_application_compute_category_using_put

        Update the category for an application  # noqa: E501
        """
        pass

    def test_edit_application_compute_tags_using_put(self):
        """Test case for edit_application_compute_tags_using_put

        Update compute tags for an application  # noqa: E501
        """
        pass

    def test_edit_application_datacenter_using_put(self):
        """Test case for edit_application_datacenter_using_put

        Update datacenter for an application  # noqa: E501
        """
        pass

    def test_edit_application_description_using_put(self):
        """Test case for edit_application_description_using_put

        Update description for an application  # noqa: E501
        """
        pass

    def test_edit_application_disk_bandwidth_limit_using_put(self):
        """Test case for edit_application_disk_bandwidth_limit_using_put

        Update disk bandwidth limit for an application  # noqa: E501
        """
        pass

    def test_edit_application_disk_iops_limit_using_put(self):
        """Test case for edit_application_disk_iops_limit_using_put

        Update disk iops limit for an application  # noqa: E501
        """
        pass

    def test_edit_application_disk_name_using_put(self):
        """Test case for edit_application_disk_name_using_put

        Update disk name for an application  # noqa: E501
        """
        pass

    def test_edit_application_disk_size_using_put(self):
        """Test case for edit_application_disk_size_using_put

        Resize an application disk  # noqa: E501
        """
        pass

    def test_edit_application_memory_using_put(self):
        """Test case for edit_application_memory_using_put

        Update memory for an application  # noqa: E501
        """
        pass

    def test_edit_application_migration_zone_using_put(self):
        """Test case for edit_application_migration_zone_using_put

        Update migration zone for an application  # noqa: E501
        """
        pass

    def test_edit_application_name_using_put(self):
        """Test case for edit_application_name_using_put

        Update name for an application  # noqa: E501
        """
        pass

    def test_edit_application_vcpus_using_put(self):
        """Test case for edit_application_vcpus_using_put

        Update virtual CPUs for an application  # noqa: E501
        """
        pass

    def test_edit_application_vnic_firewall_using_put(self):
        """Test case for edit_application_vnic_firewall_using_put

        Update vNIC firewall override for an application  # noqa: E501
        """
        pass

    def test_edit_application_vnic_mac_address_using_put(self):
        """Test case for edit_application_vnic_mac_address_using_put

        Update vNIC MAC address for an application  # noqa: E501
        """
        pass

    def test_edit_application_vnic_name_using_put(self):
        """Test case for edit_application_vnic_name_using_put

        Update vNIC name for an application  # noqa: E501
        """
        pass

    def test_edit_application_vnic_type_using_put(self):
        """Test case for edit_application_vnic_type_using_put

        Update vNIC networking mode for an application  # noqa: E501
        """
        pass

    def test_toggle_application_automatic_recovery_using_put(self):
        """Test case for toggle_application_automatic_recovery_using_put

        Toggle automatic recovery for an application  # noqa: E501
        """
        pass

    def test_toggle_application_hardware_assisted_virtualization_using_put(self):
        """Test case for toggle_application_hardware_assisted_virtualization_using_put

        Toggle nested virtualization for an application  # noqa: E501
        """
        pass

    def test_toggle_application_vm_mode_using_put(self):
        """Test case for toggle_application_vm_mode_using_put

        Update virtual machine mode for an application  # noqa: E501
        """
        pass


if __name__ == '__main__':
    unittest.main()
