#   Copyright (c) 2020 Lenovo.  All rights reserved.

#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at

#       http://www.apache.org/licenses/LICENSE-2.0

#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.


"""
    CP Web Services (CPWS)

    CP web services provides API access to the ThinkAgile CP on-premises cloud platform. It provides access to virtual datacenter and infrastructure resources and is used to create resizable resources, manage workloads and retrieve information about the underlying infrastructure. CPWS will continue to grow as new capabilities are added to the platform.  # noqa: E501

    OpenAPI spec version: Beta
    Contact: lenovo-email
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class ApiFirewallProfilePropertiesPayload(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'rules': 'list[ApiFirewallProfileRulePropertiesPayload]',
        'uuid': 'str'
    }

    attribute_map = {
        'name': 'name',
        'rules': 'rules',
        'uuid': 'uuid'
    }

    def __init__(self, name=None, rules=None, uuid=None):  # noqa: E501
        """ApiFirewallProfilePropertiesPayload - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._rules = None
        self._uuid = None
        self.discriminator = None
        if name is not None:
            self.name = name
        if rules is not None:
            self.rules = rules
        if uuid is not None:
            self.uuid = uuid

    @property
    def name(self):
        """Gets the name of this ApiFirewallProfilePropertiesPayload.  # noqa: E501


        :return: The name of this ApiFirewallProfilePropertiesPayload.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ApiFirewallProfilePropertiesPayload.


        :param name: The name of this ApiFirewallProfilePropertiesPayload.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def rules(self):
        """Gets the rules of this ApiFirewallProfilePropertiesPayload.  # noqa: E501


        :return: The rules of this ApiFirewallProfilePropertiesPayload.  # noqa: E501
        :rtype: list[ApiFirewallProfileRulePropertiesPayload]
        """
        return self._rules

    @rules.setter
    def rules(self, rules):
        """Sets the rules of this ApiFirewallProfilePropertiesPayload.


        :param rules: The rules of this ApiFirewallProfilePropertiesPayload.  # noqa: E501
        :type: list[ApiFirewallProfileRulePropertiesPayload]
        """

        self._rules = rules

    @property
    def uuid(self):
        """Gets the uuid of this ApiFirewallProfilePropertiesPayload.  # noqa: E501


        :return: The uuid of this ApiFirewallProfilePropertiesPayload.  # noqa: E501
        :rtype: str
        """
        return self._uuid

    @uuid.setter
    def uuid(self, uuid):
        """Sets the uuid of this ApiFirewallProfilePropertiesPayload.


        :param uuid: The uuid of this ApiFirewallProfilePropertiesPayload.  # noqa: E501
        :type: str
        """

        self._uuid = uuid

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ApiFirewallProfilePropertiesPayload, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApiFirewallProfilePropertiesPayload):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
