#   Copyright (c) 2020 Lenovo.  All rights reserved.

#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at

#       http://www.apache.org/licenses/LICENSE-2.0

#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.


"""
    CP Web Services (CPWS)

    CP web services provides API access to the ThinkAgile CP on-premises cloud platform. It provides access to virtual datacenter and infrastructure resources and is used to create resizable resources, manage workloads and retrieve information about the underlying infrastructure. CPWS will continue to grow as new capabilities are added to the platform.  # noqa: E501

    OpenAPI spec version: Beta
    Contact: lenovo-email
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class ApiNetworkPayload(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'firewall_profile_uuid': 'str',
        'network_name': 'str',
        'network_uuid': 'str'
    }

    attribute_map = {
        'firewall_profile_uuid': 'firewallProfileUuid',
        'network_name': 'networkName',
        'network_uuid': 'networkUuid'
    }

    def __init__(self, firewall_profile_uuid=None, network_name=None, network_uuid=None):  # noqa: E501
        """ApiNetworkPayload - a model defined in Swagger"""  # noqa: E501
        self._firewall_profile_uuid = None
        self._network_name = None
        self._network_uuid = None
        self.discriminator = None
        if firewall_profile_uuid is not None:
            self.firewall_profile_uuid = firewall_profile_uuid
        if network_name is not None:
            self.network_name = network_name
        if network_uuid is not None:
            self.network_uuid = network_uuid

    @property
    def firewall_profile_uuid(self):
        """Gets the firewall_profile_uuid of this ApiNetworkPayload.  # noqa: E501


        :return: The firewall_profile_uuid of this ApiNetworkPayload.  # noqa: E501
        :rtype: str
        """
        return self._firewall_profile_uuid

    @firewall_profile_uuid.setter
    def firewall_profile_uuid(self, firewall_profile_uuid):
        """Sets the firewall_profile_uuid of this ApiNetworkPayload.


        :param firewall_profile_uuid: The firewall_profile_uuid of this ApiNetworkPayload.  # noqa: E501
        :type: str
        """

        self._firewall_profile_uuid = firewall_profile_uuid

    @property
    def network_name(self):
        """Gets the network_name of this ApiNetworkPayload.  # noqa: E501


        :return: The network_name of this ApiNetworkPayload.  # noqa: E501
        :rtype: str
        """
        return self._network_name

    @network_name.setter
    def network_name(self, network_name):
        """Sets the network_name of this ApiNetworkPayload.


        :param network_name: The network_name of this ApiNetworkPayload.  # noqa: E501
        :type: str
        """

        self._network_name = network_name

    @property
    def network_uuid(self):
        """Gets the network_uuid of this ApiNetworkPayload.  # noqa: E501


        :return: The network_uuid of this ApiNetworkPayload.  # noqa: E501
        :rtype: str
        """
        return self._network_uuid

    @network_uuid.setter
    def network_uuid(self, network_uuid):
        """Sets the network_uuid of this ApiNetworkPayload.


        :param network_uuid: The network_uuid of this ApiNetworkPayload.  # noqa: E501
        :type: str
        """

        self._network_uuid = network_uuid

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ApiNetworkPayload, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApiNetworkPayload):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
